(define (domain bulldozer)
(:predicates (road ?x ?y - place)
             (bridge ?x ?y - place)
             (mobile ?x - thing)
             (not-mobile ?x - thing)
             (person ?x - thing)
             (driving ?x ?y - thing)
             (vehicle ?x - thing)
             (at ?x - thing ?y - place))

(:action drive
 :parameters (?from - place ?to - place  ?thing - thing)
 :precondition  (and (road ?from ?to) (at ?thing ?from) (mobile ?thing))
 :effect (and (at ?thing ?to) (not (at ?thing ?from))))


(:action cross
 :parameters (?from - place ?to - place  ?thing - thing)
 :precondition  (and (bridge ?from ?to) (at ?thing ?from) (person ?thing))
 :effect (and (at ?thing ?to) (not (at ?thing ?from))))


(:action board
 :parameters (?person - thing ?place  - place ?vehicle - thing)
 :precondition  (and (at ?person ?place) (at ?vehicle ?place)  
                     (vehicle ?vehicle) (not-mobile ?vehicle) (person ?person))
 :effect (and (driving ?person ?vehicle) (mobile ?vehicle) 
              (not (at ?person ?place)) 
              (not (not-mobile ?vehicle))))

(:action disembark
 :parameters (?person - thing ?place -  place ?vehicle - thing)
 :precondition  (and (driving ?person ?vehicle) (at ?vehicle ?place)) 
 :effect (and (at ?person ?place)  (not-mobile ?vehicle)
              (not (mobile ?vehicle)) (not (driving ?person ?vehicle)))))
